mac80211: add missing newline for "min_tx_power"
[openwrt/openwrt.git] / package / kernel / mac80211 / files / lib / netifd / wireless / mac80211.sh
1 #!/bin/sh
2 . /lib/netifd/netifd-wireless.sh
3 . /lib/netifd/hostapd.sh
4 . /lib/functions/system.sh
5
6 init_wireless_driver "$@"
7
8 MP_CONFIG_INT="mesh_retry_timeout mesh_confirm_timeout mesh_holding_timeout mesh_max_peer_links
9 mesh_max_retries mesh_ttl mesh_element_ttl mesh_hwmp_max_preq_retries
10 mesh_path_refresh_time mesh_min_discovery_timeout mesh_hwmp_active_path_timeout
11 mesh_hwmp_preq_min_interval mesh_hwmp_net_diameter_traversal_time mesh_hwmp_rootmode
12 mesh_hwmp_rann_interval mesh_gate_announcements mesh_sync_offset_max_neighor
13 mesh_rssi_threshold mesh_hwmp_active_path_to_root_timeout mesh_hwmp_root_interval
14 mesh_hwmp_confirmation_interval mesh_awake_window mesh_plink_timeout"
15 MP_CONFIG_BOOL="mesh_auto_open_plinks mesh_fwding"
16 MP_CONFIG_STRING="mesh_power_mode"
17
18 wdev_tool() {
19 ucode /usr/share/hostap/wdev.uc "$@"
20 }
21
22 drv_mac80211_init_device_config() {
23 hostapd_common_add_device_config
24
25 config_add_string path phy 'macaddr:macaddr'
26 config_add_string tx_burst
27 config_add_string distance
28 config_add_int beacon_int chanbw frag rts
29 config_add_int rxantenna txantenna txpower min_tx_power
30 config_add_int num_global_macaddr multiple_bssid
31 config_add_boolean noscan ht_coex acs_exclude_dfs background_radar
32 config_add_array ht_capab
33 config_add_array channels
34 config_add_array scan_list
35 config_add_boolean \
36 rxldpc \
37 short_gi_80 \
38 short_gi_160 \
39 tx_stbc_2by1 \
40 su_beamformer \
41 su_beamformee \
42 mu_beamformer \
43 mu_beamformee \
44 he_su_beamformer \
45 he_su_beamformee \
46 he_mu_beamformer \
47 vht_txop_ps \
48 htc_vht \
49 rx_antenna_pattern \
50 tx_antenna_pattern \
51 he_spr_sr_control \
52 he_spr_psr_enabled \
53 he_bss_color_enabled \
54 he_twt_required
55 config_add_int \
56 beamformer_antennas \
57 beamformee_antennas \
58 vht_max_a_mpdu_len_exp \
59 vht_max_mpdu \
60 vht_link_adapt \
61 vht160 \
62 rx_stbc \
63 tx_stbc \
64 he_bss_color \
65 he_spr_non_srg_obss_pd_max_offset
66 config_add_boolean \
67 ldpc \
68 greenfield \
69 short_gi_20 \
70 short_gi_40 \
71 max_amsdu \
72 dsss_cck_40
73 }
74
75 drv_mac80211_init_iface_config() {
76 hostapd_common_add_bss_config
77
78 config_add_string 'macaddr:macaddr' ifname
79
80 config_add_boolean wds powersave enable
81 config_add_string wds_bridge
82 config_add_int maxassoc
83 config_add_int max_listen_int
84 config_add_int dtim_period
85 config_add_int start_disabled
86
87 # mesh
88 config_add_string mesh_id
89 config_add_int $MP_CONFIG_INT
90 config_add_boolean $MP_CONFIG_BOOL
91 config_add_string $MP_CONFIG_STRING
92 }
93
94 mac80211_add_capabilities() {
95 local __var="$1"; shift
96 local __mask="$1"; shift
97 local __out= oifs
98
99 oifs="$IFS"
100 IFS=:
101 for capab in "$@"; do
102 set -- $capab
103
104 [ "$(($4))" -gt 0 ] || continue
105 [ "$(($__mask & $2))" -eq "$((${3:-$2}))" ] || continue
106 __out="$__out[$1]"
107 done
108 IFS="$oifs"
109
110 export -n -- "$__var=$__out"
111 }
112
113 mac80211_add_he_capabilities() {
114 local __out= oifs
115
116 oifs="$IFS"
117 IFS=:
118 for capab in "$@"; do
119 set -- $capab
120 [ "$(($4))" -gt 0 ] || continue
121 [ "$(((0x$2) & $3))" -gt 0 ] || {
122 eval "$1=0"
123 continue
124 }
125 append base_cfg "$1=1" "$N"
126 done
127 IFS="$oifs"
128 }
129
130 mac80211_hostapd_setup_base() {
131 local phy="$1"
132
133 json_select config
134
135 [ "$auto_channel" -gt 0 ] && channel=acs_survey
136
137 [ "$auto_channel" -gt 0 ] && json_get_vars acs_exclude_dfs
138 [ -n "$acs_exclude_dfs" ] && [ "$acs_exclude_dfs" -gt 0 ] &&
139 append base_cfg "acs_exclude_dfs=1" "$N"
140
141 json_get_vars noscan ht_coex min_tx_power:0 tx_burst
142 json_get_values ht_capab_list ht_capab
143 json_get_values channel_list channels
144
145 [ "$auto_channel" = 0 ] && [ -z "$channel_list" ] && \
146 channel_list="$channel"
147
148 [ "$min_tx_power" -gt 0 ] && append base_cfg "min_tx_power=$min_tx_power" "$N"
149
150 set_default noscan 0
151
152 [ "$noscan" -gt 0 ] && hostapd_noscan=1
153 [ "$tx_burst" = 0 ] && tx_burst=
154
155 chan_ofs=0
156 [ "$band" = "6g" ] && chan_ofs=1
157
158 ieee80211n=1
159 ht_capab=
160 case "$htmode" in
161 VHT20|HT20|HE20) ;;
162 HT40*|VHT40|VHT80|VHT160|HE40|HE80|HE160)
163 case "$hwmode" in
164 a)
165 case "$(( (($channel / 4) + $chan_ofs) % 2 ))" in
166 1) ht_capab="[HT40+]";;
167 0) ht_capab="[HT40-]";;
168 esac
169 ;;
170 *)
171 case "$htmode" in
172 HT40+) ht_capab="[HT40+]";;
173 HT40-) ht_capab="[HT40-]";;
174 *)
175 if [ "$channel" -lt 7 ]; then
176 ht_capab="[HT40+]"
177 else
178 ht_capab="[HT40-]"
179 fi
180 ;;
181 esac
182 ;;
183 esac
184 [ "$auto_channel" -gt 0 ] && ht_capab="[HT40+]"
185 ;;
186 *) ieee80211n= ;;
187 esac
188
189 [ -n "$ieee80211n" ] && {
190 append base_cfg "ieee80211n=1" "$N"
191
192 set_default ht_coex 0
193 append base_cfg "ht_coex=$ht_coex" "$N"
194
195 json_get_vars \
196 ldpc:1 \
197 greenfield:0 \
198 short_gi_20:1 \
199 short_gi_40:1 \
200 tx_stbc:1 \
201 rx_stbc:3 \
202 max_amsdu:1 \
203 dsss_cck_40:1
204
205 ht_cap_mask=0
206 for cap in $(iw phy "$phy" info | grep 'Capabilities:' | cut -d: -f2); do
207 ht_cap_mask="$(($ht_cap_mask | $cap))"
208 done
209
210 cap_rx_stbc=$((($ht_cap_mask >> 8) & 3))
211 [ "$rx_stbc" -lt "$cap_rx_stbc" ] && cap_rx_stbc="$rx_stbc"
212 ht_cap_mask="$(( ($ht_cap_mask & ~(0x300)) | ($cap_rx_stbc << 8) ))"
213
214 mac80211_add_capabilities ht_capab_flags $ht_cap_mask \
215 LDPC:0x1::$ldpc \
216 GF:0x10::$greenfield \
217 SHORT-GI-20:0x20::$short_gi_20 \
218 SHORT-GI-40:0x40::$short_gi_40 \
219 TX-STBC:0x80::$tx_stbc \
220 RX-STBC1:0x300:0x100:1 \
221 RX-STBC12:0x300:0x200:1 \
222 RX-STBC123:0x300:0x300:1 \
223 MAX-AMSDU-7935:0x800::$max_amsdu \
224 DSSS_CCK-40:0x1000::$dsss_cck_40
225
226 ht_capab="$ht_capab$ht_capab_flags"
227 [ -n "$ht_capab" ] && append base_cfg "ht_capab=$ht_capab" "$N"
228 }
229
230 # 802.11ac
231 enable_ac=0
232 vht_oper_chwidth=0
233 vht_center_seg0=
234
235 idx="$channel"
236 case "$htmode" in
237 VHT20|HE20) enable_ac=1;;
238 VHT40|HE40)
239 case "$(( (($channel / 4) + $chan_ofs) % 2 ))" in
240 1) idx=$(($channel + 2));;
241 0) idx=$(($channel - 2));;
242 esac
243 enable_ac=1
244 vht_center_seg0=$idx
245 ;;
246 VHT80|HE80)
247 case "$(( (($channel / 4) + $chan_ofs) % 4 ))" in
248 1) idx=$(($channel + 6));;
249 2) idx=$(($channel + 2));;
250 3) idx=$(($channel - 2));;
251 0) idx=$(($channel - 6));;
252 esac
253 enable_ac=1
254 vht_oper_chwidth=1
255 vht_center_seg0=$idx
256 ;;
257 VHT160|HE160)
258 if [ "$band" = "6g" ]; then
259 case "$channel" in
260 1|5|9|13|17|21|25|29) idx=15;;
261 33|37|41|45|49|53|57|61) idx=47;;
262 65|69|73|77|81|85|89|93) idx=79;;
263 97|101|105|109|113|117|121|125) idx=111;;
264 129|133|137|141|145|149|153|157) idx=143;;
265 161|165|169|173|177|181|185|189) idx=175;;
266 193|197|201|205|209|213|217|221) idx=207;;
267 esac
268 else
269 case "$channel" in
270 36|40|44|48|52|56|60|64) idx=50;;
271 100|104|108|112|116|120|124|128) idx=114;;
272 esac
273 fi
274 enable_ac=1
275 vht_oper_chwidth=2
276 vht_center_seg0=$idx
277 ;;
278 esac
279 [ "$band" = "5g" ] && {
280 json_get_vars background_radar:0
281
282 [ "$background_radar" -eq 1 ] && append base_cfg "enable_background_radar=1" "$N"
283 }
284 [ "$band" = "6g" ] && {
285 op_class=
286 case "$htmode" in
287 HE20) op_class=131;;
288 HE*) op_class=$((132 + $vht_oper_chwidth))
289 esac
290 [ -n "$op_class" ] && append base_cfg "op_class=$op_class" "$N"
291 }
292 [ "$hwmode" = "a" ] || enable_ac=0
293
294 if [ "$enable_ac" != "0" ]; then
295 json_get_vars \
296 rxldpc:1 \
297 short_gi_80:1 \
298 short_gi_160:1 \
299 tx_stbc_2by1:1 \
300 su_beamformer:1 \
301 su_beamformee:1 \
302 mu_beamformer:1 \
303 mu_beamformee:1 \
304 vht_txop_ps:1 \
305 htc_vht:1 \
306 beamformee_antennas:4 \
307 beamformer_antennas:4 \
308 rx_antenna_pattern:1 \
309 tx_antenna_pattern:1 \
310 vht_max_a_mpdu_len_exp:7 \
311 vht_max_mpdu:11454 \
312 rx_stbc:4 \
313 vht_link_adapt:3 \
314 vht160:2
315
316 set_default tx_burst 2.0
317 append base_cfg "ieee80211ac=1" "$N"
318 vht_cap=0
319 for cap in $(iw phy "$phy" info | awk -F "[()]" '/VHT Capabilities/ { print $2 }'); do
320 vht_cap="$(($vht_cap | $cap))"
321 done
322
323 append base_cfg "vht_oper_chwidth=$vht_oper_chwidth" "$N"
324 append base_cfg "vht_oper_centr_freq_seg0_idx=$vht_center_seg0" "$N"
325
326 cap_rx_stbc=$((($vht_cap >> 8) & 7))
327 [ "$rx_stbc" -lt "$cap_rx_stbc" ] && cap_rx_stbc="$rx_stbc"
328 vht_cap="$(( ($vht_cap & ~(0x700)) | ($cap_rx_stbc << 8) ))"
329
330 mac80211_add_capabilities vht_capab $vht_cap \
331 RXLDPC:0x10::$rxldpc \
332 SHORT-GI-80:0x20::$short_gi_80 \
333 SHORT-GI-160:0x40::$short_gi_160 \
334 TX-STBC-2BY1:0x80::$tx_stbc_2by1 \
335 SU-BEAMFORMER:0x800::$su_beamformer \
336 SU-BEAMFORMEE:0x1000::$su_beamformee \
337 MU-BEAMFORMER:0x80000::$mu_beamformer \
338 MU-BEAMFORMEE:0x100000::$mu_beamformee \
339 VHT-TXOP-PS:0x200000::$vht_txop_ps \
340 HTC-VHT:0x400000::$htc_vht \
341 RX-ANTENNA-PATTERN:0x10000000::$rx_antenna_pattern \
342 TX-ANTENNA-PATTERN:0x20000000::$tx_antenna_pattern \
343 RX-STBC-1:0x700:0x100:1 \
344 RX-STBC-12:0x700:0x200:1 \
345 RX-STBC-123:0x700:0x300:1 \
346 RX-STBC-1234:0x700:0x400:1 \
347
348 [ "$(($vht_cap & 0x800))" -gt 0 -a "$su_beamformer" -gt 0 ] && {
349 cap_ant="$(( ( ($vht_cap >> 16) & 3 ) + 1 ))"
350 [ "$cap_ant" -gt "$beamformer_antennas" ] && cap_ant="$beamformer_antennas"
351 [ "$cap_ant" -gt 1 ] && vht_capab="$vht_capab[SOUNDING-DIMENSION-$cap_ant]"
352 }
353
354 [ "$(($vht_cap & 0x1000))" -gt 0 -a "$su_beamformee" -gt 0 ] && {
355 cap_ant="$(( ( ($vht_cap >> 13) & 3 ) + 1 ))"
356 [ "$cap_ant" -gt "$beamformee_antennas" ] && cap_ant="$beamformee_antennas"
357 [ "$cap_ant" -gt 1 ] && vht_capab="$vht_capab[BF-ANTENNA-$cap_ant]"
358 }
359
360 # supported Channel widths
361 vht160_hw=0
362 [ "$(($vht_cap & 12))" -eq 4 -a 1 -le "$vht160" ] && \
363 vht160_hw=1
364 [ "$(($vht_cap & 12))" -eq 8 -a 2 -le "$vht160" ] && \
365 vht160_hw=2
366 [ "$vht160_hw" = 1 ] && vht_capab="$vht_capab[VHT160]"
367 [ "$vht160_hw" = 2 ] && vht_capab="$vht_capab[VHT160-80PLUS80]"
368
369 # maximum MPDU length
370 vht_max_mpdu_hw=3895
371 [ "$(($vht_cap & 3))" -ge 1 -a 7991 -le "$vht_max_mpdu" ] && \
372 vht_max_mpdu_hw=7991
373 [ "$(($vht_cap & 3))" -ge 2 -a 11454 -le "$vht_max_mpdu" ] && \
374 vht_max_mpdu_hw=11454
375 [ "$vht_max_mpdu_hw" != 3895 ] && \
376 vht_capab="$vht_capab[MAX-MPDU-$vht_max_mpdu_hw]"
377
378 # maximum A-MPDU length exponent
379 vht_max_a_mpdu_len_exp_hw=0
380 [ "$(($vht_cap & 58720256))" -ge 8388608 -a 1 -le "$vht_max_a_mpdu_len_exp" ] && \
381 vht_max_a_mpdu_len_exp_hw=1
382 [ "$(($vht_cap & 58720256))" -ge 16777216 -a 2 -le "$vht_max_a_mpdu_len_exp" ] && \
383 vht_max_a_mpdu_len_exp_hw=2
384 [ "$(($vht_cap & 58720256))" -ge 25165824 -a 3 -le "$vht_max_a_mpdu_len_exp" ] && \
385 vht_max_a_mpdu_len_exp_hw=3
386 [ "$(($vht_cap & 58720256))" -ge 33554432 -a 4 -le "$vht_max_a_mpdu_len_exp" ] && \
387 vht_max_a_mpdu_len_exp_hw=4
388 [ "$(($vht_cap & 58720256))" -ge 41943040 -a 5 -le "$vht_max_a_mpdu_len_exp" ] && \
389 vht_max_a_mpdu_len_exp_hw=5
390 [ "$(($vht_cap & 58720256))" -ge 50331648 -a 6 -le "$vht_max_a_mpdu_len_exp" ] && \
391 vht_max_a_mpdu_len_exp_hw=6
392 [ "$(($vht_cap & 58720256))" -ge 58720256 -a 7 -le "$vht_max_a_mpdu_len_exp" ] && \
393 vht_max_a_mpdu_len_exp_hw=7
394 vht_capab="$vht_capab[MAX-A-MPDU-LEN-EXP$vht_max_a_mpdu_len_exp_hw]"
395
396 # whether or not the STA supports link adaptation using VHT variant
397 vht_link_adapt_hw=0
398 [ "$(($vht_cap & 201326592))" -ge 134217728 -a 2 -le "$vht_link_adapt" ] && \
399 vht_link_adapt_hw=2
400 [ "$(($vht_cap & 201326592))" -ge 201326592 -a 3 -le "$vht_link_adapt" ] && \
401 vht_link_adapt_hw=3
402 [ "$vht_link_adapt_hw" != 0 ] && \
403 vht_capab="$vht_capab[VHT-LINK-ADAPT-$vht_link_adapt_hw]"
404
405 [ -n "$vht_capab" ] && append base_cfg "vht_capab=$vht_capab" "$N"
406 fi
407
408 # 802.11ax
409 enable_ax=0
410 case "$htmode" in
411 HE*) enable_ax=1 ;;
412 esac
413
414 if [ "$enable_ax" != "0" ]; then
415 json_get_vars \
416 he_su_beamformer:1 \
417 he_su_beamformee:1 \
418 he_mu_beamformer:1 \
419 he_twt_required:0 \
420 he_spr_sr_control:3 \
421 he_spr_psr_enabled:0 \
422 he_spr_non_srg_obss_pd_max_offset:0 \
423 he_bss_color:128 \
424 he_bss_color_enabled:1
425
426 he_phy_cap=$(iw phy "$phy" info | sed -n '/HE Iftypes: AP/,$p' | awk -F "[()]" '/HE PHY Capabilities/ { print $2 }' | head -1)
427 he_phy_cap=${he_phy_cap:2}
428 he_mac_cap=$(iw phy "$phy" info | sed -n '/HE Iftypes: AP/,$p' | awk -F "[()]" '/HE MAC Capabilities/ { print $2 }' | head -1)
429 he_mac_cap=${he_mac_cap:2}
430
431 append base_cfg "ieee80211ax=1" "$N"
432 [ "$hwmode" = "a" ] && {
433 append base_cfg "he_oper_chwidth=$vht_oper_chwidth" "$N"
434 append base_cfg "he_oper_centr_freq_seg0_idx=$vht_center_seg0" "$N"
435 }
436
437 mac80211_add_he_capabilities \
438 he_su_beamformer:${he_phy_cap:6:2}:0x80:$he_su_beamformer \
439 he_su_beamformee:${he_phy_cap:8:2}:0x1:$he_su_beamformee \
440 he_mu_beamformer:${he_phy_cap:8:2}:0x2:$he_mu_beamformer \
441 he_spr_psr_enabled:${he_phy_cap:14:2}:0x1:$he_spr_psr_enabled \
442 he_twt_required:${he_mac_cap:0:2}:0x6:$he_twt_required
443
444 if [ "$he_bss_color_enabled" -gt 0 ]; then
445 append base_cfg "he_bss_color=$he_bss_color" "$N"
446 [ "$he_spr_non_srg_obss_pd_max_offset" -gt 0 ] && { \
447 append base_cfg "he_spr_non_srg_obss_pd_max_offset=$he_spr_non_srg_obss_pd_max_offset" "$N"
448 he_spr_sr_control=$((he_spr_sr_control | (1 << 2)))
449 }
450 [ "$he_spr_psr_enabled" -gt 0 ] || he_spr_sr_control=$((he_spr_sr_control | (1 << 0)))
451 append base_cfg "he_spr_sr_control=$he_spr_sr_control" "$N"
452 else
453 append base_cfg "he_bss_color_disabled=1" "$N"
454 fi
455
456
457 append base_cfg "he_default_pe_duration=4" "$N"
458 append base_cfg "he_rts_threshold=1023" "$N"
459 append base_cfg "he_mu_edca_qos_info_param_count=0" "$N"
460 append base_cfg "he_mu_edca_qos_info_q_ack=0" "$N"
461 append base_cfg "he_mu_edca_qos_info_queue_request=0" "$N"
462 append base_cfg "he_mu_edca_qos_info_txop_request=0" "$N"
463 append base_cfg "he_mu_edca_ac_be_aifsn=8" "$N"
464 append base_cfg "he_mu_edca_ac_be_aci=0" "$N"
465 append base_cfg "he_mu_edca_ac_be_ecwmin=9" "$N"
466 append base_cfg "he_mu_edca_ac_be_ecwmax=10" "$N"
467 append base_cfg "he_mu_edca_ac_be_timer=255" "$N"
468 append base_cfg "he_mu_edca_ac_bk_aifsn=15" "$N"
469 append base_cfg "he_mu_edca_ac_bk_aci=1" "$N"
470 append base_cfg "he_mu_edca_ac_bk_ecwmin=9" "$N"
471 append base_cfg "he_mu_edca_ac_bk_ecwmax=10" "$N"
472 append base_cfg "he_mu_edca_ac_bk_timer=255" "$N"
473 append base_cfg "he_mu_edca_ac_vi_ecwmin=5" "$N"
474 append base_cfg "he_mu_edca_ac_vi_ecwmax=7" "$N"
475 append base_cfg "he_mu_edca_ac_vi_aifsn=5" "$N"
476 append base_cfg "he_mu_edca_ac_vi_aci=2" "$N"
477 append base_cfg "he_mu_edca_ac_vi_timer=255" "$N"
478 append base_cfg "he_mu_edca_ac_vo_aifsn=5" "$N"
479 append base_cfg "he_mu_edca_ac_vo_aci=3" "$N"
480 append base_cfg "he_mu_edca_ac_vo_ecwmin=5" "$N"
481 append base_cfg "he_mu_edca_ac_vo_ecwmax=7" "$N"
482 append base_cfg "he_mu_edca_ac_vo_timer=255" "$N"
483 fi
484
485 hostapd_prepare_device_config "$hostapd_conf_file" nl80211
486 cat >> "$hostapd_conf_file" <<EOF
487 ${channel:+channel=$channel}
488 ${channel_list:+chanlist=$channel_list}
489 ${hostapd_noscan:+noscan=1}
490 ${tx_burst:+tx_queue_data2_burst=$tx_burst}
491 ${multiple_bssid:+mbssid=$multiple_bssid}
492 #num_global_macaddr=$num_global_macaddr
493 $base_cfg
494
495 EOF
496 json_select ..
497 }
498
499 mac80211_hostapd_setup_bss() {
500 local phy="$1"
501 local ifname="$2"
502 local macaddr="$3"
503 local type="$4"
504
505 hostapd_cfg=
506 append hostapd_cfg "$type=$ifname" "$N"
507
508 hostapd_set_bss_options hostapd_cfg "$phy" "$vif" || return 1
509 json_get_vars wds wds_bridge dtim_period max_listen_int start_disabled
510
511 set_default wds 0
512 set_default start_disabled 0
513
514 [ "$wds" -gt 0 ] && {
515 append hostapd_cfg "wds_sta=1" "$N"
516 [ -n "$wds_bridge" ] && append hostapd_cfg "wds_bridge=$wds_bridge" "$N"
517 }
518 [ "$staidx" -gt 0 -o "$start_disabled" -eq 1 ] && append hostapd_cfg "start_disabled=1" "$N"
519
520 cat >> /var/run/hostapd-$phy.conf <<EOF
521 $hostapd_cfg
522 bssid=$macaddr
523 ${default_macaddr:+#default_macaddr}
524 ${dtim_period:+dtim_period=$dtim_period}
525 ${max_listen_int:+max_listen_interval=$max_listen_int}
526 EOF
527 }
528
529 mac80211_get_addr() {
530 local phy="$1"
531 local idx="$(($2 + 1))"
532
533 head -n $idx /sys/class/ieee80211/${phy}/addresses | tail -n1
534 }
535
536 mac80211_generate_mac() {
537 local phy="$1"
538 local id="${macidx:-0}"
539
540 wdev_tool "$phy" get_macaddr id=$id num_global=$num_global_macaddr mbssid=${multiple_bssid:-0}
541 }
542
543 get_board_phy_name() (
544 local path="$1"
545 local fallback_phy=""
546
547 __check_phy() {
548 local val="$1"
549 local key="$2"
550 local ref_path="$3"
551
552 json_select "$key"
553 json_get_values path
554 json_select ..
555
556 [ "${ref_path%+*}" = "$path" ] && fallback_phy=$key
557 [ "$ref_path" = "$path" ] || return 0
558
559 echo "$key"
560 exit
561 }
562
563 json_load_file /etc/board.json
564 json_for_each_item __check_phy wlan "$path"
565 [ -n "$fallback_phy" ] && echo "${fallback_phy}.${path##*+}"
566 )
567
568 rename_board_phy_by_path() {
569 local path="$1"
570
571 local new_phy="$(get_board_phy_name "$path")"
572 [ -z "$new_phy" -o "$new_phy" = "$phy" ] && return
573
574 iw "$phy" set name "$new_phy" && phy="$new_phy"
575 }
576
577 rename_board_phy_by_name() (
578 local phy="$1"
579 local suffix="${phy##*.}"
580 [ "$suffix" = "$phy" ] && suffix=
581
582 json_load_file /etc/board.json
583 json_select wlan
584 json_select "${phy%.*}" || return 0
585 json_get_values path
586
587 prev_phy="$(iwinfo nl80211 phyname "path=$path${suffix:++$suffix}")"
588 [ -n "$prev_phy" ] || return 0
589
590 [ "$prev_phy" = "$phy" ] && return 0
591
592 iw "$prev_phy" set name "$phy"
593 )
594
595 find_phy() {
596 [ -n "$phy" ] && {
597 rename_board_phy_by_name "$phy"
598 [ -d /sys/class/ieee80211/$phy ] && return 0
599 }
600 [ -n "$path" ] && {
601 phy="$(iwinfo nl80211 phyname "path=$path")"
602 [ -n "$phy" ] && {
603 rename_board_phy_by_path "$path"
604 return 0
605 }
606 }
607 [ -n "$macaddr" ] && {
608 for phy in $(ls /sys/class/ieee80211 2>/dev/null); do
609 grep -i -q "$macaddr" "/sys/class/ieee80211/${phy}/macaddress" && {
610 path="$(iwinfo nl80211 path "$phy")"
611 rename_board_phy_by_path "$path"
612 return 0
613 }
614 done
615 }
616 return 1
617 }
618
619 mac80211_check_ap() {
620 has_ap=1
621 }
622
623 mac80211_set_ifname() {
624 local phy="$1"
625 local prefix="$2"
626 eval "ifname=\"$phy-$prefix\${idx_$prefix:-0}\"; idx_$prefix=\$((\${idx_$prefix:-0 } + 1))"
627 }
628
629 mac80211_prepare_vif() {
630 json_select config
631
632 json_get_vars ifname mode ssid wds powersave macaddr enable wpa_psk_file vlan_file
633
634 [ -n "$ifname" ] || {
635 local prefix;
636
637 case "$mode" in
638 ap|sta|mesh) prefix=$mode;;
639 adhoc) prefix=ibss;;
640 monitor) prefix=mon;;
641 esac
642
643 mac80211_set_ifname "$phy" "$prefix"
644 }
645
646 append active_ifnames "$ifname"
647 set_default wds 0
648 set_default powersave 0
649 json_add_string _ifname "$ifname"
650
651 default_macaddr=
652 if [ -z "$macaddr" ]; then
653 macaddr="$(mac80211_generate_mac $phy)"
654 macidx="$(($macidx + 1))"
655 default_macaddr=1
656 elif [ "$macaddr" = 'random' ]; then
657 macaddr="$(macaddr_random)"
658 fi
659 json_add_string _macaddr "$macaddr"
660 json_add_string _default_macaddr "$default_macaddr"
661 json_select ..
662
663
664 [ "$mode" == "ap" ] && {
665 [ -z "$wpa_psk_file" ] && hostapd_set_psk "$ifname"
666 [ -z "$vlan_file" ] && hostapd_set_vlan "$ifname"
667 }
668
669 json_select config
670
671 # It is far easier to delete and create the desired interface
672 case "$mode" in
673 ap)
674 # Hostapd will handle recreating the interface and
675 # subsequent virtual APs belonging to the same PHY
676 if [ -n "$hostapd_ctrl" ]; then
677 type=bss
678 else
679 type=interface
680 fi
681
682 mac80211_hostapd_setup_bss "$phy" "$ifname" "$macaddr" "$type" || return
683
684 [ -n "$hostapd_ctrl" ] || {
685 ap_ifname="${ifname}"
686 hostapd_ctrl="${hostapd_ctrl:-/var/run/hostapd/$ifname}"
687 }
688 ;;
689 esac
690
691 json_select ..
692 }
693
694 mac80211_prepare_iw_htmode() {
695 case "$htmode" in
696 VHT20|HT20|HE20) iw_htmode=HT20;;
697 HT40*|VHT40|VHT160|HE40)
698 case "$band" in
699 2g)
700 case "$htmode" in
701 HT40+) iw_htmode="HT40+";;
702 HT40-) iw_htmode="HT40-";;
703 *)
704 if [ "$channel" -lt 7 ]; then
705 iw_htmode="HT40+"
706 else
707 iw_htmode="HT40-"
708 fi
709 ;;
710 esac
711 ;;
712 *)
713 case "$(( ($channel / 4) % 2 ))" in
714 1) iw_htmode="HT40+" ;;
715 0) iw_htmode="HT40-";;
716 esac
717 ;;
718 esac
719 [ "$auto_channel" -gt 0 ] && iw_htmode="HT40+"
720 ;;
721 VHT80|HE80)
722 iw_htmode="80MHZ"
723 ;;
724 NONE|NOHT)
725 iw_htmode="NOHT"
726 ;;
727 *) iw_htmode="" ;;
728 esac
729 }
730
731 mac80211_add_mesh_params() {
732 for var in $MP_CONFIG_INT $MP_CONFIG_BOOL $MP_CONFIG_STRING; do
733 eval "mp_val=\"\$$var\""
734 [ -n "$mp_val" ] && json_add_string "$var" "$mp_val"
735 done
736 }
737
738 mac80211_setup_adhoc() {
739 local enable=$1
740 json_get_vars bssid ssid key mcast_rate
741
742 NEWUMLIST="${NEWUMLIST}$ifname "
743
744 [ "$enable" = 0 ] && {
745 ip link set dev "$ifname" down
746 return 0
747 }
748
749 keyspec=
750 [ "$auth_type" = "wep" ] && {
751 set_default key 1
752 case "$key" in
753 [1234])
754 local idx
755 for idx in 1 2 3 4; do
756 json_get_var ikey "key$idx"
757
758 [ -n "$ikey" ] && {
759 ikey="$(($idx - 1)):$(prepare_key_wep "$ikey")"
760 [ $idx -eq $key ] && ikey="d:$ikey"
761 append keyspec "$ikey"
762 }
763 done
764 ;;
765 *)
766 append keyspec "d:0:$(prepare_key_wep "$key")"
767 ;;
768 esac
769 }
770
771 brstr=
772 for br in $basic_rate_list; do
773 wpa_supplicant_add_rate brstr "$br"
774 done
775
776 mcval=
777 [ -n "$mcast_rate" ] && wpa_supplicant_add_rate mcval "$mcast_rate"
778
779 local prev
780 json_set_namespace wdev_uc prev
781
782 json_add_object "$ifname"
783 json_add_string mode adhoc
784 [ -n "$default_macaddr" ] || json_add_string macaddr "$macaddr"
785 json_add_string ssid "$ssid"
786 json_add_string freq "$freq"
787 json_add_string htmode "$iw_htmode"
788 [ -n "$bssid" ] && json_add_string bssid "$bssid"
789 json_add_int beacon-interval "$beacon_int"
790 [ -n "$brstr" ] && json_add_string basic-rates "$brstr"
791 [ -n "$mcval" ] && json_add_string mcast-rate "$mcval"
792 [ -n "$keyspec" ] && json_add_string keys "$keyspec"
793 json_close_object
794
795 json_set_namespace "$prev"
796 }
797
798 mac80211_setup_mesh() {
799 json_get_vars ssid mesh_id mcast_rate
800
801 mcval=
802 [ -n "$mcast_rate" ] && wpa_supplicant_add_rate mcval "$mcast_rate"
803 [ -n "$mesh_id" ] && ssid="$mesh_id"
804
805 local prev
806 json_set_namespace wdev_uc prev
807
808 json_add_object "$ifname"
809 json_add_string mode mesh
810 [ -n "$default_macaddr" ] || json_add_string macaddr "$macaddr"
811 json_add_string ssid "$ssid"
812 json_add_string freq "$freq"
813 json_add_string htmode "$iw_htmode"
814 [ -n "$mcval" ] && json_add_string mcast-rate "$mcval"
815 json_add_int beacon-interval "$beacon_int"
816 mac80211_add_mesh_params
817
818 json_close_object
819
820 json_set_namespace "$prev"
821 }
822
823 mac80211_setup_monitor() {
824 local prev
825 json_set_namespace wdev_uc prev
826
827 json_add_object "$ifname"
828 json_add_string mode monitor
829 [ -n "$freq" ] && json_add_string freq "$freq"
830 json_add_string htmode "$iw_htmode"
831 json_close_object
832
833 json_set_namespace "$prev"
834 }
835
836 mac80211_set_vif_txpower() {
837 local name="$1"
838
839 json_select config
840 json_get_var ifname _ifname
841 json_get_vars vif_txpower
842 json_select ..
843
844 [ -z "$vif_txpower" ] || iw dev "$ifname" set txpower fixed "${vif_txpower%%.*}00"
845 }
846
847 wpa_supplicant_init_config() {
848 json_set_namespace wpa_supp prev
849
850 json_init
851 json_add_array config
852
853 json_set_namespace "$prev"
854 }
855
856 wpa_supplicant_add_interface() {
857 local ifname="$1"
858 local mode="$2"
859 local prev
860
861 _wpa_supplicant_common "$ifname"
862
863 json_set_namespace wpa_supp prev
864
865 json_add_object
866 json_add_string ctrl "$_rpath"
867 json_add_string iface "$ifname"
868 json_add_string mode "$mode"
869 json_add_string config "$_config"
870 [ -n "$default_macaddr" ] || json_add_string macaddr "$macaddr"
871 [ -n "$network_bridge" ] && json_add_string bridge "$network_bridge"
872 [ -n "$wds" ] && json_add_boolean 4addr "$wds"
873 json_add_boolean powersave "$powersave"
874 [ "$mode" = "mesh" ] && mac80211_add_mesh_params
875 json_close_object
876
877 json_set_namespace "$prev"
878
879 wpa_supp_init=1
880 }
881
882 wpa_supplicant_set_config() {
883 local phy="$1"
884 local prev
885
886 json_set_namespace wpa_supp prev
887 json_close_array
888 json_add_string phy "$phy"
889 json_add_boolean defer 1
890 local data="$(json_dump)"
891
892 json_cleanup
893 json_set_namespace "$prev"
894
895 ubus -S -t 0 wait_for wpa_supplicant || {
896 [ -n "$wpa_supp_init" ] || return 0
897
898 ubus wait_for wpa_supplicant
899 }
900
901 local supplicant_res="$(ubus call wpa_supplicant config_set "$data")"
902 ret="$?"
903 [ "$ret" != 0 -o -z "$supplicant_res" ] && wireless_setup_vif_failed WPA_SUPPLICANT_FAILED
904
905 wireless_add_process "$(jsonfilter -s "$supplicant_res" -l 1 -e @.pid)" "/usr/sbin/wpa_supplicant" 1 1
906
907 }
908
909 hostapd_set_config() {
910 [ -n "$hostapd_ctrl" ] || {
911 ubus call hostapd config_set '{ "phy": "'"$phy"'", "config": "", "prev_config": "'"${hostapd_conf_file}.prev"'" }' > /dev/null
912 return 0;
913 }
914
915 ubus wait_for hostapd
916 local hostapd_res="$(ubus call hostapd config_set "{ \"phy\": \"$phy\", \"config\":\"${hostapd_conf_file}\", \"prev_config\": \"${hostapd_conf_file}.prev\"}")"
917 ret="$?"
918 [ "$ret" != 0 -o -z "$hostapd_res" ] && {
919 wireless_setup_failed HOSTAPD_START_FAILED
920 return
921 }
922 wireless_add_process "$(jsonfilter -s "$hostapd_res" -l 1 -e @.pid)" "/usr/sbin/hostapd" 1 1
923 }
924
925
926 wpa_supplicant_start() {
927 local phy="$1"
928
929 [ -n "$wpa_supp_init" ] || return 0
930
931 ubus call wpa_supplicant config_set '{ "phy": "'"$phy"'" }' > /dev/null
932 }
933
934 mac80211_setup_supplicant() {
935 local enable=$1
936 local add_sp=0
937
938 wpa_supplicant_prepare_interface "$ifname" nl80211 || return 1
939
940 if [ "$mode" = "sta" ]; then
941 wpa_supplicant_add_network "$ifname"
942 else
943 wpa_supplicant_add_network "$ifname" "$freq" "$htmode" "$hostapd_noscan"
944 fi
945
946 wpa_supplicant_add_interface "$ifname" "$mode"
947
948 return 0
949 }
950
951 mac80211_setup_vif() {
952 local name="$1"
953 local failed
954
955 json_select config
956 json_get_var ifname _ifname
957 json_get_var macaddr _macaddr
958 json_get_var default_macaddr _default_macaddr
959 json_get_vars mode wds powersave
960
961 set_default powersave 0
962 set_default wds 0
963
964 case "$mode" in
965 mesh)
966 json_get_vars $MP_CONFIG_INT $MP_CONFIG_BOOL $MP_CONFIG_STRING
967 wireless_vif_parse_encryption
968 [ -z "$htmode" ] && htmode="NOHT";
969 if wpa_supplicant -vmesh; then
970 mac80211_setup_supplicant || failed=1
971 else
972 mac80211_setup_mesh
973 fi
974 ;;
975 adhoc)
976 wireless_vif_parse_encryption
977 if [ "$wpa" -gt 0 -o "$auto_channel" -gt 0 ]; then
978 mac80211_setup_supplicant || failed=1
979 else
980 mac80211_setup_adhoc
981 fi
982 ;;
983 sta)
984 mac80211_setup_supplicant || failed=1
985 ;;
986 monitor)
987 mac80211_setup_monitor
988 ;;
989 esac
990
991 json_select ..
992 [ -n "$failed" ] || wireless_add_vif "$name" "$ifname"
993 }
994
995 get_freq() {
996 local phy="$1"
997 local channel="$2"
998 local band="$3"
999
1000 case "$band" in
1001 2g) band="1:";;
1002 5g) band="2:";;
1003 60g) band="3:";;
1004 6g) band="4:";;
1005 esac
1006
1007 iw "$phy" info | awk -v band="$band" -v channel="[$channel]" '
1008
1009 $1 ~ /Band/ {
1010 band_match = band == $2
1011 }
1012
1013 band_match && $3 == "MHz" && $4 == channel {
1014 print $2
1015 exit
1016 }
1017 '
1018 }
1019
1020 chan_is_dfs() {
1021 local phy="$1"
1022 local chan="$2"
1023 iw "$phy" info | grep -E -m1 "(\* ${chan:-....} MHz${chan:+|\\[$chan\\]})" | grep -q "MHz.*radar detection"
1024 return $!
1025 }
1026
1027 mac80211_set_noscan() {
1028 hostapd_noscan=1
1029 }
1030
1031 drv_mac80211_cleanup() {
1032 hostapd_common_cleanup
1033 }
1034
1035 mac80211_reset_config() {
1036 local phy="$1"
1037
1038 hostapd_conf_file="/var/run/hostapd-$phy.conf"
1039 ubus call hostapd config_set '{ "phy": "'"$phy"'", "config": "", "prev_config": "'"$hostapd_conf_file"'" }' > /dev/null
1040 ubus call wpa_supplicant config_set '{ "phy": "'"$phy"'", "config": [] }' > /dev/null
1041 wdev_tool "$phy" set_config '{}'
1042 }
1043
1044 drv_mac80211_setup() {
1045 json_select config
1046 json_get_vars \
1047 phy macaddr path \
1048 country chanbw distance \
1049 txpower \
1050 rxantenna txantenna \
1051 frag rts beacon_int:100 htmode \
1052 num_global_macaddr:1 multiple_bssid
1053 json_get_values basic_rate_list basic_rate
1054 json_get_values scan_list scan_list
1055 json_select ..
1056
1057 json_select data && {
1058 json_get_var prev_rxantenna rxantenna
1059 json_get_var prev_txantenna txantenna
1060 json_select ..
1061 }
1062
1063 find_phy || {
1064 echo "Could not find PHY for device '$1'"
1065 wireless_set_retry 0
1066 return 1
1067 }
1068
1069 local wdev
1070 local cwdev
1071 local found
1072
1073 # convert channel to frequency
1074 [ "$auto_channel" -gt 0 ] || freq="$(get_freq "$phy" "$channel" "$band")"
1075
1076 [ -n "$country" ] && {
1077 iw reg get | grep -q "^country $country:" || {
1078 iw reg set "$country"
1079 sleep 1
1080 }
1081 }
1082
1083 hostapd_conf_file="/var/run/hostapd-$phy.conf"
1084
1085 macidx=0
1086 staidx=0
1087
1088 [ -n "$chanbw" ] && {
1089 for file in /sys/kernel/debug/ieee80211/$phy/ath9k*/chanbw /sys/kernel/debug/ieee80211/$phy/ath5k/bwmode; do
1090 [ -f "$file" ] && echo "$chanbw" > "$file"
1091 done
1092 }
1093
1094 set_default rxantenna 0xffffffff
1095 set_default txantenna 0xffffffff
1096 set_default distance 0
1097
1098 [ "$txantenna" = "all" ] && txantenna=0xffffffff
1099 [ "$rxantenna" = "all" ] && rxantenna=0xffffffff
1100
1101 [ "$rxantenna" = "$prev_rxantenna" -a "$txantenna" = "$prev_txantenna" ] || mac80211_reset_config "$phy"
1102 wireless_set_data phy="$phy" txantenna="$txantenna" rxantenna="$rxantenna"
1103
1104 iw phy "$phy" set antenna $txantenna $rxantenna >/dev/null 2>&1
1105 iw phy "$phy" set distance "$distance" >/dev/null 2>&1
1106
1107 if [ -n "$txpower" ]; then
1108 iw phy "$phy" set txpower fixed "${txpower%%.*}00"
1109 else
1110 iw phy "$phy" set txpower auto
1111 fi
1112
1113 [ -n "$frag" ] && iw phy "$phy" set frag "${frag%%.*}"
1114 [ -n "$rts" ] && iw phy "$phy" set rts "${rts%%.*}"
1115
1116 has_ap=
1117 hostapd_ctrl=
1118 ap_ifname=
1119 hostapd_noscan=
1120 wpa_supp_init=
1121 for_each_interface "ap" mac80211_check_ap
1122
1123 [ -f "$hostapd_conf_file" ] && mv "$hostapd_conf_file" "$hostapd_conf_file.prev"
1124
1125 for_each_interface "sta adhoc mesh" mac80211_set_noscan
1126 [ -n "$has_ap" ] && mac80211_hostapd_setup_base "$phy"
1127
1128 local prev
1129 json_set_namespace wdev_uc prev
1130 json_init
1131 json_set_namespace "$prev"
1132
1133 wpa_supplicant_init_config
1134
1135 mac80211_prepare_iw_htmode
1136 active_ifnames=
1137 for_each_interface "ap sta adhoc mesh monitor" mac80211_prepare_vif
1138 for_each_interface "ap sta adhoc mesh monitor" mac80211_setup_vif
1139
1140 [ -x /usr/sbin/wpa_supplicant ] && wpa_supplicant_set_config "$phy"
1141 [ -x /usr/sbin/hostapd ] && hostapd_set_config "$phy"
1142
1143 [ -x /usr/sbin/wpa_supplicant ] && wpa_supplicant_start "$phy"
1144
1145 json_set_namespace wdev_uc prev
1146 wdev_tool "$phy" set_config "$(json_dump)" $active_ifnames
1147 json_set_namespace "$prev"
1148
1149 for_each_interface "ap sta adhoc mesh monitor" mac80211_set_vif_txpower
1150 wireless_set_up
1151 }
1152
1153 _list_phy_interfaces() {
1154 local phy="$1"
1155 if [ -d "/sys/class/ieee80211/${phy}/device/net" ]; then
1156 ls "/sys/class/ieee80211/${phy}/device/net" 2>/dev/null;
1157 else
1158 ls "/sys/class/ieee80211/${phy}/device" 2>/dev/null | grep net: | sed -e 's,net:,,g'
1159 fi
1160 }
1161
1162 list_phy_interfaces() {
1163 local phy="$1"
1164
1165 for dev in $(_list_phy_interfaces "$phy"); do
1166 readlink "/sys/class/net/${dev}/phy80211" | grep -q "/${phy}\$" || continue
1167 echo "$dev"
1168 done
1169 }
1170
1171 drv_mac80211_teardown() {
1172 json_select data
1173 json_get_vars phy
1174 json_select ..
1175 [ -n "$phy" ] || {
1176 echo "Bug: PHY is undefined for device '$1'"
1177 return 1
1178 }
1179
1180 mac80211_reset_config "$phy"
1181
1182 for wdev in $(list_phy_interfaces "$phy"); do
1183 ip link set dev "$wdev" down
1184 iw dev "$wdev" del
1185 done
1186 }
1187
1188 add_driver mac80211